import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// Data set URI
const csvUrl = 'https://gist.githubusercontent.com/prashanthyamala/fc7bbb6153d5cfc0e69c03f7eeff578f/raw/2670c3b7394b49a45dd77c021171d8a241ac0e6a/supermarket_sales';  

// Format the Data from the URI response
const parseRow = (d) => {
  d.Price= +d.Price;
  d.Quantity = +d.Quantity;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;

// Appends a SVG in the body of HTML
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  
  // Creating a new Scatter Plot object
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.Quantity)
    .yValue((d) => d.Price)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  // Plotting the Scatter Plot axes based on the given parameters
  svg.call(plot);

  const columns = [
    'Quantity',
    'Price',
  ];
  
  // Plotting the data on the Scatter Plot
  let i = 0;
 	setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 2000);
};
main();



